%define php_sapi apache-mod_php
%define so_file  libphp4.so

Name: apache-mod_php
Version: %php_version
Release: %php_release
Summary: The PHP4 HTML-embedded scripting language for use with Apache
Summary(ru_RU.CP1251):	  HTML   PHP4     Apache.
Group: System/Servers
Url: http://www.php.net/
License: PHP
Serial: 1

Requires: control, gdbm, zlib, mm, pam
Requires: php = %php_version
Requires: apache >= %apache_version-%apache_release
Prereq:	php-libs >= %php_version-%php_release

Source1: %name-php.conf
Source2: %name.service
Source3: php.ini.%name.alt
Source4: %name-browscap.ini
Source5: php.%name.control

Patch0: php-4.4.6-sapi-mod_php.patch

Obsoletes: mod_php3, php3, phpfi mod_php
Provides: mod_php
Provides: php-engine = %version-%release

BuildRequires(pre): rpm-build-php apache-devel

# Automatically added by buildreq on Mon May 30 2005
BuildRequires: libexpat-devel libmm-devel zlib-devel libpcre-devel
BuildRequires: php-devel = %php_version-%php_release

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.  The mod_php module enables the Apache web server to
understand and process the embedded PHP language in web pages.

This package contains PHP version 4. You'll also need to install the
Apache web server.

%description -l ru_RU.CP1251
PHP4 --   ,   HTML. PHP  
     , 
  ,   .   
 PHP    CGI-.  mod_php 
- Apache     PHP  -.

%prep
%setup -T -c
%php_sapi_prepare apache
%patch0 -p1 -b .fix

%build
%apache_apxs \
  $(php-config --includes) $(pcre-config --cflags) \
  $(php-config --ldflags) %php_optflags \
  $(php-config --libs) $(pcre-config --libs) \
  -Wl,-rpath=%_libdir/apache -L%_libdir/apache -lhttpd \
  -I. -I./include \
  -DUSE_TRANSFER_TABLES=1 \
  -lphp-%_php_version \
  -o %so_file -c *.c 

%install
%__mkdir_p \
	%buildroot/%_libdir/apache \
	%buildroot/%apache_modconfdir \
	%buildroot/%php_servicedir/%php_sapi \
	%buildroot/%php_sysconfdir/%php_sapi/php.d \
	%buildroot/%php_sysconfdir/%php_sapi/control.d \
	%buildroot/%_sysconfdir/control.d/facilities \

%__install -m 644 %SOURCE1 %buildroot/%apache_modconfdir/%name.conf
%__install -m 700 %SOURCE2 %buildroot/%php_servicedir/%php_sapi/condrestart
%__install -m 644 %SOURCE3 %buildroot/%php_sysconfdir/%php_sapi/php.ini
%__install -m 644 %SOURCE4 %buildroot/%php_sysconfdir/%php_sapi/browscap.ini
%__install -m 755 %SOURCE5 %buildroot/%_sysconfdir/control.d/facilities/%name

%__cp %so_file %buildroot/%_libdir/apache

for f in \
	%buildroot/%apache_modconfdir/%name.conf \
	%buildroot/%php_sysconfdir/%php_sapi/php.ini \
	%buildroot/%_sysconfdir/control.d/facilities/%name
do
  %__subst 's,@SAPI@,%php_sapi,g' "$f"
  %__subst 's,@PHP_BROWSCAP@,%php_sysconfdir/%php_sapi/browscap.ini,g' "$f"
  %__subst 's,@PHP_UPLOADDIR@,%apache_tmpdir/uploads,g' "$f"
  %__subst 's,@PHP_SESSIONDIR@,%apache_tmpdir/sessions,g' "$f"
  %__subst 's,@PHP_VERSION@,%_php_version,g' "$f"
  %__subst 's,@PHP_LIBDIR@,%_libdir/php,g' "$f"
  %__subst 's,@HTDOCSDIR@,%apache_htdocsdir,g' "$f"
  %__subst 's,@LIBDIR@,%_libdir,g' "$f"
done

%triggerpostun -- mod_php < 1:4.3.12-alt0.cvs20050530
if ! grep -qs "\<alt_sapi_config_ini_scan_dir\>" "%php_sysconfdir/%php_sapi/php.ini"; then
    printf '\n%%s\n' 'alt_sapi_config_ini_scan_dir = "/etc/php/%php_version/%php_sapi/php.d"' >> "%php_sysconfdir/%php_sapi/php.ini"
fi

%triggerpostun -- mod_php < 1:4.4.2-alt0.cvs20051121
if grep -qs "\<error_log_facility\>" "%php_sysconfdir/%php_sapi/php.ini"; then
	%__subst 's|^[[:space:]]*\<error_log_facility\>.*|; &|g' "%php_sysconfdir/%php_sapi/php.ini"
	%__subst 's|\<error_log_facility\>.*|& ;;; deprecated|g' "%php_sysconfdir/%php_sapi/php.ini"
	printf '\nWARNING: error_log_facility directive is deprecated. Use hphp.log.syslog.facility instead.\n\n'
fi

%post
%php_sapi_postin
%php_servicedir/%php_sapi/condrestart

%preun
%php_sapi_preun

%files
%_libdir/apache/%so_file
%_sysconfdir/control.d/facilities/*
%config(noreplace) %apache_modconfdir/%name.conf
%config(noreplace) %php_sysconfdir/%php_sapi/php.ini
%config(noreplace) %php_sysconfdir/%php_sapi/browscap.ini
%php_sysconfdir/%php_sapi
%php_servicedir/%php_sapi
%doc apache
%doc CREDITS

%changelog
* Sun May 13 2007 L.A. Kostis <lakostis@altlinux.ru> 1:4.4.7-alt1
- rebuild with new php version (4.4.7).

* Tue Apr 10 2007 L.A. Kostis <lakostis@altlinux.ru> 1:4.4.6-alt2
- rebuild due libmm soname change.

* Sun Mar 25 2007 L.A. Kostis <lakostis@altlinux.ru> 1:4.4.6-alt1.1
- update -sapi patch.
- update browsecap.ini.
- update control rules.

* Thu Mar 08 2007 L.A. Kostis <lakostis@altlinux.ru> 1:4.4.6-alt1
- prepare for release:
  + fix control script (add suhosin actions/add short_open_tag actions).

* Sun Mar 04 2007 L.A. Kostis <lakostis@altlinux.ru> 1:4.4.6-alt0.1
- new version (4.4.6).
- Fix build with gear.

* Mon Sep 11 2006 Alexey Gladkov <legion@altlinux.ru> 1:4.4.4-alt2
- Fix php.ini .

* Wed Aug 23 2006 Alexey Gladkov <legion@altlinux.ru> 1:4.4.4-alt1
- new version (4.4.4).
- fix configuration paths.

* Thu Jun 29 2006 Alexey Gladkov <legion@altlinux.ru> 1:4.4.3.cvs20060626-alt1.2
- packaging bugfix.

* Tue Jun 27 2006 Alexey Gladkov <legion@altlinux.ru> 1:4.4.3.cvs20060626-alt1.1
- added Obsoletes/Provides: mod_php

* Mon Jun 26 2006 Alexey Gladkov <legion@altlinux.ru> 1:4.4.3.cvs20060626-alt1
- new version;
- removed %%pre_control, %%post_control from post-scripts; 
- Fixed: #9551, #8681, #9052, #5944, #8502, #5990, #6421

* Fri Nov 25 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.4.2-alt0.cvs20051121.1
- control bugfix (altbug: #8557).
- control-{dump,restore} added.
- browscap.ini updated.

* Thu Nov 24 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.4.2-alt0.cvs20051121
- new cvs snapshot.

* Sun Oct 16 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.4.1-alt0.cvs20051010
- new cvs snapshot.

* Sun Aug 07 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.4.1-alt0.cvs20050729
- new CVS snapshot;

* Mon May 30 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.12-alt0.cvs20050530
- new CVS snapshot;
- new directive added:
  * alt_sapi_config_ini_scan_dir - directory to be scanned for configuration 
    files (default: /etc/php/PHP_VERSION/SAPI/php.d);

* Fri May 27 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.12-alt0.cvs20050527
- New cvs snapshot;

* Thu Apr 07 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.12-alt0.cvs20050406
- New cvs snapshot;

* Mon Apr 04 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.12-alt0.cvs20050404
- New cvs snapshot.
- spec cleanup;
- control support added;
- default configuration changed;

* Wed Feb 09 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.11-alt0.cvs20050209
- New cvs snapshot.

* Mon Dec 20 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.11-alt0.cvs20041217
- new version;
- alternative fix;

* Fri Aug 06 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.9-alt0.cvs20040802
- New cvs snapshot;
- security fixes;

* Mon May 31 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.7-alt0.cvs20040531
- New cvs snapshot;
- Environment variable PHPRC overriding is removed.

* Fri May 21 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.7-alt0.cvs20040519
- New cvs snapshot;
- From php-common was removed all librares to new package php-libs;
- Remove config files to new place /etc/php/%%php_version/mod_php/.
- default php.ini changed:
    + browscap.ini added;
    + alternatives support added;
    + variable default_charset='koi8-r' added;
    + variable define_syslog_variables=On added;

* Fri Jan 30 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.5-alt0.cvs20040130
- New cvs snapshot.
- Shared Memory support added (enable-shmop).

* Tue Jan 06 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.5-alt0.cvs20040106
- postin/preun script bugfix.

* Mon Dec 22 2003 Alexey Gladkov <legion@altlinux.ru> 1:4.3.5-alt0.cvs20031211
- New cvs snapshot php4.3.5 CVS-20031211
- build scheme fix:
  - postin bugfix (#3324).

* Wed Nov 12 2003 Alexey Gladkov <legion@altlinux.ru> 1:4.3.5-alt0.cvs20031112
- New cvs snapshot php4.3.5 CVS-20031112
- iconv support fixed.
- minor build scheme fix:
  + macro php_optflags added.
  + sapi build environment changed.

* Sat Nov 01 2003 Alexey Gladkov <legion@altlinux.ru> 1:4.3.4-alt0.cvs20031101
- New cvs snapshot
- Simple spec cleanup

* Tue Oct 21 2003 Alexey Gladkov <legion@altlinux.ru> 1:4.3.4-alt0.cvs20031017
- First standalone build for ALT Linux;
- building by apxs;
- new configuraion scheme;
  - Fixed #2939, #2940.
